Ext.define("demo.view.OldMain", {
   extend : "Ext.container.Container",
   alias  : "widget.demoOldMain",

   controller : "demoMainController",

   title   : "demo Module",
   iconCls : "x-fal fa-hand-peace",

   layout : "border",

   moduleId : undefined, // will be applied by bpc-fe-core - can be undefined

   viewModel : {
      data : {
         eins              : 1,
         zwei              : 2,
         drei              : 3,
         wahrheitswert     : true,
         /**
             * Hier wird vom Monitor der record platziert
             */
         record            : undefined,
         notificationType  : "INFO",
         notificationToast : false,
         measurement       : { no: "data" }
      },
      formulas : {
         performanceResult : function (get) {
            return JSON.stringify(get("measurement"), undefined, 2);
         }
      }
   },

   items : [
      {
         xtype      : "panel",
         scrollable : true,
         layout     : {
            type  : "vbox",
            align : "stretch"
         },
         region  : "center",
         padding : 10,
         items   : [
            {
               xtype       : "fieldset",
               collapsible : true,
               collapsed   : true,
               defaults    : { anchor: "100%" },
               title       : "Data-Binding",
               items       : [
                  {
                     xtype      : "textfield",
                     fieldLabel : "Eins",
                     bind       : "{eins}"
                  },
                  {
                     xtype      : "textfield",
                     fieldLabel : "Zwei",
                     bind       : "{zwei}"
                  },
                  {
                     xtype      : "textfield",
                     fieldLabel : "Drei",
                     bind       : "{drei}"
                  },
                  {
                     xtype      : "checkbox",
                     fieldLabel : "Chat?",
                     bind       : "{wahrheitswert}"
                  }
               ]
            },
            {
               xtype       : "fieldset",
               collapsible : true,
               collapsed   : true,
               defaults    : { anchor: "100%" },
               title       : "Monitor Daten",
               itemId      : "monitorData",
               items       : [
                  {
                     xtype : "box",
                     html  : "Kein Monitor angebunden"
                  }
               ]
            },
            {
               xtype       : "fieldset",
               collapsible : true,
               defaults    : { anchor: "100%" },
               title       : "Notifications",
               itemId      : "notificationFieldSet",
               items       : [
                  {
                     xtype      : "textfield",
                     fieldLabel : "Text",
                     bind       : "{notificationText}"
                  },
                  {
                     xtype      : "radiogroup",
                     fieldLabel : "Typ",
                     columns    : 4,
                     bind       : "{notificationType}",
                     items      : [
                        {
                           boxLabel   : "Information",
                           name       : "notificationType",
                           inputValue : "INFO"
                        },
                        {
                           boxLabel   : "Warnung",
                           name       : "notificationType",
                           inputValue : "WARNING"
                        },
                        {
                           boxLabel   : "Fehler",
                           name       : "notificationType",
                           inputValue : "ERROR"
                        },
                        {
                           boxLabel   : "Frage",
                           name       : "notificationType",
                           inputValue : "QUESTION"
                        }
                     ]
                  },
                  {
                     xtype      : "checkboxgroup",
                     fieldLabel : "Optionen",
                     columns    : 4,
                     items      : [
                        {
                           boxLabel : "PopUp",
                           bind     : "{notificationPopUp}"
                        },
                        {
                           boxLabel : "Toast",
                           bind     : "{notificationToast}"
                        },
                        {
                           boxLabel : "Silent",
                           bind     : "{notificationSilent}"
                        }
                     ]
                  },
                  {
                     xtype      : "radiogroup",
                     fieldLabel : "Toast Ziel",
                     columns    : 4,
                     bind       : {
                        value    : "{notificationToastTarget}",
                        disabled : "{!notificationToast}"
                     },
                     items : [
                        {
                           boxLabel   : "Global",
                           name       : "notificationToastTarget",
                           inputValue : "global",
                           checked    : true
                        },
                        {
                           boxLabel   : "Modul",
                           name       : "notificationToastTarget",
                           inputValue : "module"
                        },
                        {
                           boxLabel   : "Fieldset",
                           name       : "notificationToastTarget",
                           inputValue : "fieldset"
                        }
                     ]
                  },
                  {
                     xtype   : "button",
                     iconCls : "x-fal fa-envelope",
                     text    : "Senden",
                     handler : "sendNotification"
                  }
               ]
            },
            {
               xtype       : "fieldset",
               collapsible : true,
               collapsed   : true,
               defaults    : { anchor: "100%" },
               title       : "Konfigurationsmanagement",
               items       : [
                  {
                     xtype      : "colorselector",
                     fieldLabel : "Stage Color"
                  },
                  {
                     xtype      : "textfield",
                     fieldLabel : "Modulname",
                     bind       : "{moduleNameSetting.value}"
                  }
               ]
            },
            {
               xtype       : "fieldset",
               collapsible : true,
               collapsed   : true,
               defaults    : { anchor: "100%" },
               title       : "Perfomance Daten",
               items       : [
                  {
                     xtype   : "button",
                     text    : "Start",
                     iconCls : "x-fal fa-play",
                     handler : "startMeasure"
                  },
                  {
                     xtype   : "button",
                     text    : "Stop",
                     iconCls : "x-fal fa-stop",
                     handler : "stopMeasure"
                  },
                  {
                     xtype      : "textarea",
                     fieldLabel : "Ergebnis",
                     bind       : "{performanceResult}",
                     grow       : true
                  }
               ]
            }
         ],
         buttons : [
            {
               xtype      : "button",
               iconCls    : "x-fal fa-lock",
               text       : "Sperren",
               buttonType : "applyLock",
               handler    : "applyLock"
            },
            {
               xtype   : "button",
               iconCls : "x-fal fa-lock-open",
               text    : "Entsperren",
               handler : "releaseLock"
            },
            {
               text    : "In die Toolbar",
               iconCls : "x-fal fa-arrow-to-top",
               handler : "injectButtons"
            },
            "->",
            // {
            //    text   : "Hallo",
            //    handler: "eineFunktion"
            // },
            {
               text    : "Chat Demo",
               iconCls : "x-fal fa-comments",
               handler : "letsChat"
            }
         ]
      },
      {
         region         : "west",
         xtype          : "demoTestView",
         inputParameter : "hello world south",
         split          : true,
         collapsible    : true,
         collapsed      : true,
         width          : 150
      },
      {
         region : "east",
         xtype  : "demoChat",
         split  : true,
         bind   : {
            hidden : "{!wahrheitswert}"
         },
         width : 500
      }
   ],

   initComponent : function () {

      this.record; // datensatz aus monitor
      this.getViewModel().set("record", this.record);

      if (this.moduleId) {
         this.getViewModel().set("moduleNameSetting", BpcCommon.Api.getSetting(this.moduleId, "module_name", true));
      }

      this.callParent();
   }
});