/**
 * Created by andre on 25.09.18.
 */
Ext.define("demo.view.chat.ChatController", {
   extend : "Ext.app.ViewController",
   alias  : "controller.demoChatController",

   control : {
      "textfield" : {
         specialkey : "onSpecialKey"
      }
   },

   listen : {
      global : {
         chat : "onChat"
      }
   },

   init : function () {
      Ext.fireEvent("chat", {
         text : `${BpcCommon.Api.getUserName()  } joined the chat `,
         user : "✌️Virtimo",
         date : new Date()
      });
   },

   onSpecialKey : function (source, e) {
      Ext.log({
         msg   : `${this.self.getName()  }: onSpecialKey`,
         level : "info"
      });
      if (e.getKey() === e.ENTER) {
         Ext.fireEvent("chat", {
            text : source.getValue(),
            user : BpcCommon.Api.getUserName(),
            date : new Date()
         });
         source.reset();
      }
   },

   onChat : function (event) {
      Ext.log({
         msg   : `${this.self.getName()  }: onChat`,
         level : "info"
      });
      if (!event.properties) {
         return;
      }
      const chatObject = event.properties.data;

      const target   = this.getView().down("textarea");
      const oldValue = target.getValue();
      target.setValue(`${oldValue  }\n${  Ext.Date.format(new Date(chatObject.date), "H:i:s")  } - ${  chatObject.user  }: ${  chatObject.text}`);
   }

});