/**
 * Created by andre on 21.08.20
 */
Ext.define("demo.view.components.AccountPlugins", {
   extend : "Ext.panel.Panel",
   alias  : "widget.demoAccountPlugins",
    
   title : "Account Plugins",
    
   layout : {
      type : "vbox"
   },
    
   items : [
      {
         xtype               : "bpcAccountToolbar",
         pluginConfiguration : { configuration: {} }
      },
      {
         xtype               : "bpcAccountToolbar",
         pluginConfiguration : {
            configuration : {
               userTextTpl    : "{global.userSession.firstName} {global.userSession.lastName}",
               userTooltipTpl : "{global.userSession.firstName} {global.userSession.lastName} ({global.userSession.loginName}",
               changeLanguage : true,
               accountPage    : true,
               logout         : true,
               changePw       : true,
               icon           : true,
               buttonArrow    : false,
               buttonLogout   : false
            }
         }
      },
      {
         xtype               : "bpcAccountToolbar",
         pluginConfiguration : {
            configuration : {
               userTextTpl    : "changeLanguage: true",
               changeLanguage : true,
               accountPage    : false,
               logout         : false,
               changePw       : false,
               icon           : false,
               buttonArrow    : false,
               buttonLogout   : false
            }
         }
      },
      {
         xtype               : "bpcAccountToolbar",
         pluginConfiguration : {
            configuration : {
               userTextTpl    : "accountPage: true",
               changeLanguage : false,
               accountPage    : true,
               logout         : false,
               changePw       : false,
               icon           : false,
               buttonArrow    : false,
               buttonLogout   : false
            }
         }
      },
      {
         xtype               : "bpcAccountToolbar",
         pluginConfiguration : {
            configuration : {
               userTextTpl    : "logout: true",
               changeLanguage : false,
               accountPage    : false,
               logout         : true,
               changePw       : false,
               icon           : false,
               buttonArrow    : false,
               buttonLogout   : false
            }
         }
      },
      {
         xtype               : "bpcAccountToolbar",
         pluginConfiguration : {
            configuration : {
               userTextTpl    : "changePw: true",
               changeLanguage : false,
               accountPage    : false,
               logout         : false,
               changePw       : true,
               icon           : false,
               buttonArrow    : false,
               buttonLogout   : false
            }
         }
      },
      {
         xtype               : "bpcAccountToolbar",
         pluginConfiguration : {
            configuration : {
               userTextTpl    : "icon: true + accountPage: true",
               changeLanguage : false,
               accountPage    : true,
               logout         : false,
               changePw       : false,
               icon           : true,
               buttonArrow    : false,
               buttonLogout   : false
            }
         }
      },
      {
         xtype               : "bpcAccountToolbar",
         pluginConfiguration : {
            configuration : {
               userTextTpl    : "buttonArrow: true + accountPage: true",
               changeLanguage : false,
               accountPage    : true,
               logout         : false,
               changePw       : false,
               icon           : false,
               buttonArrow    : true,
               buttonLogout   : false
            }
         }
      },
      {
         xtype               : "bpcAccountToolbar",
         pluginConfiguration : {
            configuration : {
               userTextTpl    : "buttonLogout: true + accountPage: true",
               changeLanguage : false,
               accountPage    : true,
               logout         : false,
               changePw       : false,
               icon           : false,
               buttonArrow    : false,
               buttonLogout   : true
            }
         }
      },
      {
         xtype : "button",
         text  : "AccountMenu Plugin Demo",
         menu  : [
            {
               xtype : "bpcAccountMenu"
            },
                
            {
               xtype               : "bpcAccountMenu",
               pluginConfiguration : {
                  configuration : {
                     userTextTpl    : "User {global.userSession.loginName}",
                     userTooltipTpl : "Hello <b>X {global.userSession.firstName} X</b>"
                  }
               }
            },
                
            {
               xtype               : "bpcAccountMenu",
               pluginConfiguration : {
                  configuration : {
                     userTextTpl    : "changeLanguage: true",
                     changeLanguage : true,
                     accountPage    : false,
                     logout         : false,
                     changePw       : false,
                     icon           : false
                  }
               }
            },
                
            {
               xtype               : "bpcAccountMenu",
               pluginConfiguration : {
                  configuration : {
                     userTextTpl    : "accountPage: true",
                     changeLanguage : false,
                     accountPage    : true,
                     logout         : false,
                     changePw       : false,
                     icon           : false
                  }
               }
            },
                
            {
               xtype               : "bpcAccountMenu",
               pluginConfiguration : {
                  configuration : {
                     userTextTpl    : "logout: true",
                     changeLanguage : false,
                     accountPage    : false,
                     logout         : true,
                     changePw       : false,
                     icon           : false
                  }
               }
            },
                
            {
               xtype               : "bpcAccountMenu",
               pluginConfiguration : {
                  configuration : {
                     userTextTpl    : "changePw: true",
                     changeLanguage : false,
                     accountPage    : false,
                     logout         : false,
                     changePw       : true,
                     icon           : false
                  }
               }
            },
                
            {
               xtype               : "bpcAccountMenu",
               pluginConfiguration : {
                  configuration : {
                     userTextTpl    : "icon: true",
                     changeLanguage : false,
                     accountPage    : false,
                     logout         : false,
                     changePw       : false,
                     icon           : true
                  }
               }
            }
         ]
      }
   ]
});