/**
 * Created by andre on 05.05.21
 */
Ext.define("demo.view.components.FieldValidator", {
   extend : "Ext.tab.Panel",
   alias  : "widget.demoFieldValidator",

   title    : "Field Validator",
   defaults : {
      layout : {
         type : "vbox"
      },
      bodyPadding : 10,
      items       : [
         {
            xtype      : "bpcTextField",
            allowBlank : false,
            fieldLabel : "Mandatory text field",
            msgTarget  : "side"
         },
         {
            xtype      : "bpcNumberField",
            value      : 42,
            minValue   : 23,
            maxValue   : 23,
            fieldLabel : "Number field which only accepts 23",
            msgTarget  : "side"
         },
         {
            xtype : "button",
            text  : "Simple button"
         },
         {
            xtype             : "button",
            text              : "Button linked to validation",
            enableOnValidForm : true
         }
      ]
   },
   
   items : [
      {
         xtype   : "panel",
         title   : "Injected in Toolbar",
         tbar    : [], // we need at least one toolbar, bbar, buttons or any other toolbar within this panel are fine
         plugins : {
            bpcFieldValidator : {
               autoInjectValidationButton : true
            }
         }
      },
   
      {
         xtype : "panel",
         title : "Custom btn via default itemId",
         tbar  : [
            {
               xtype   : "button",
               iconCls : "x-fal fa-fire",
               text    : "this text will be overridden by the plugin",
               itemId  : "formChecker" // this is the default itemId
            }
         ],
         plugins : {
            bpcFieldValidator : {
               markInvalidOnHighlight   : true, // triggers also the field validation error msg
               validationButtonSelector : "#formChecker" // this is the default value in bpcFieldValidator
            }
         }
      }
   ]
   
});