/**
 * Created by andre on 16.10.18.
 */
Ext.define("demo.view.main.DemoContainer", {
   extend : "Ext.Panel",
   alias  : "widget.demoDemoContainer",

   demoConfig : {},

   dockedItems : [

      {
         xtype             : "demoSourceCodeViewer",
         width             : 500,
         dock              : "right",
         resizable         : true,
         collapsible       : true,
         collapseDirection : "right"
      }
   ],

   layout : "fit",
   
   stateful : true,
   stateId  : "demoContainer",

   initComponent : function () {
      const me = this;

      /* Set text as routePath*/
      const route = me.record.get("text");
      Ext.apply(me.demoConfig, {
         routePath : route
      });
      me.items = [
         me.demoConfig
      ];

      me.callParent();

      const codeViewer = me.down("demoSourceCodeViewer");
      const demoFiles  = me.demoConfig.files;
      const errMessage = "Code preview nicht verfügbar";

      /* No file has been set*/
      if (!Ext.isArray(demoFiles) || demoFiles.length === 0) {
         codeViewer.add({
            xtype : "bpcCenterMessageCmp",
            html  : errMessage
         });
         codeViewer.collapse();
      }


      Ext.Array.each(demoFiles, function (file) {
         /* Im gradle build werden die Quelldateien in den Build resources Ordner kopiert und sind von daher so erreichbar*/
         Ext.Ajax.request({ url     : `bpc-fe-demo/resources/src/${  file}`,
            success : function (response) {
               codeViewer.add({
                  title : file.split("/").pop(),
                  xtype : "bpcJavascriptField",
                  value : response.responseText
               });
               codeViewer.expand();
            },
            failure : function () {
               codeViewer.add({
                  xtype : "bpcCenterMessageCmp",
                  html  : errMessage
               });
               codeViewer.collapse();

            } });


      });
   }

});