Ext.define("demo.view.theme.Main", {
   extend  : "Ext.panel.Panel",
   alias   : "widget.demoThemeMain",
   iconCls : "x-fal fa-pencil",
   title   : "BPC Theme",
   itmeId  : "demoThemeMain",

   controller : "demoThemeMainController",
   
   viewModel : {
      data : {
         notificationType  : "INFO",
         notificationToast : false,
         measurement       : { no: "data" },
         disabled          : false
      }
   },
   
   layout : {
      type  : "vbox",
      align : "stretch"
   },
   
   scrollable : true,
   
   defaultButtonSet : [
      {
         text : "Primary",
         ui   : "primary"
      },
      {
         text         : "P pressed",
         ui           : "primary",
         enableToggle : true,
         pressed      : true
      },
      {
         text : "Secondary",
         ui   : "secondary"
      },
      {
         text         : "S pressed",
         ui           : "secondary",
         enableToggle : true,
         pressed      : true
      },
      {
         text    : "Destructive",
         ui      : "destructive",
         iconCls : "x-fal fa-trash-alt"
      },
      {
         text    : "Destructive Secondary",
         iconCls : "x-fal fa-trash-alt",
         ui      : "destructiveSecondary"
      },
      {
         text : "Default"
      },
      {
         text         : "pressed",
         enableToggle : true,
         pressed      : true
      },
      {
         iconCls : BpcCommon.Icons.FAV
      },
      {
         iconCls : BpcCommon.Icons.FAV,
         text    : "With Icon"
      },
      {
         xtype   : "splitbutton",
         iconCls : BpcCommon.Icons.FAV,
         text    : "Split Button",
         menu    : {
            items : [
               // these will render as dropdown menu items when the arrow is clicked:
               { text: "Item 1" },
               { text: "Item 2" }
            ]
         }
      }
   ].map((btn) => {
      // set defaults
      return Ext.applyIf(btn, {
         xtype : "button",
         bind  : {
            disabled : "{disabled}",
            tooltip  : "{disabled ? \"Buttons are disabled\" : \"Button tooltip\"}"
         }
      });
   }),
   
   bbar : [
      {
         xtype    : "checkbox",
         boxLabel : "Disabled",
         bind     : "{disabled}"
      }
   ],
   
   initComponent : function () {
      const me = this;
      
      me.items = [
         {
            title      : "Panels Demo",
            xtype      : "panel",
            header     : false,
            scrollable : true,
            layout     : {
               type  : "hbox",
               align : "stretch"
            },
            defaults : {
               margin    : 8,
               overflowY : "scroll",
               width     : 200,
               height    : 200
            },
            items : [
               {
                  xtype : "panel",
                  title : "Panel framed",
                  frame : true,
                  items : [
                     { html: "Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet." }
                  ]
               },
               {
                  xtype       : "panel",
                  title       : "Collapsible",
                  collapsible : true,
                  frame       : true,
                  items       : [
                     { html: "Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet." }
                  ]
               },
               {
                  xtype  : "panel",
                  title  : "Panel Masked",
                  itemId : "maskedPanel",
                  frame  : true,
                  items  : [
                     { html: "Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet." }
                  ],
                  buttons : [
                     {
                        text    : "load...",
                        handler : "showLoadingMask"
                     }
                  ]
               },
               {
                  xtype : "panel",
                  title : "Panel NOT Framed",
                  frame : false,
                  items : [
                     { html: "Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet." }
                  ]
               },
               {
                  xtype       : "panel",
                  layout      : "center",
                  title       : "Collapsible",
                  collapsible : true,
                  overflowY   : "scroll",
                  frame       : false,
                  width       : 200,
                  height      : 200,
                  items       : [
                     { html: "Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet." }
                  ]
               }
      
      
            ]
         },
   
         {
            title      : "Panel Layouts",
            xtype      : "panel",
            header     : false,
            scrollable : true,
            layout     : {
               type  : "hbox",
               align : "stretch"
            },
            defaults : {
               margin : 8
            },
            items : [
               {
                  xtype  : "panel",
                  width  : 200,
                  height : 300,
                  layout : {
                     // layout-specific configs go here
                     type          : "accordion",
                     titleCollapse : false,
                     animate       : false,
                     activeOnTop   : false
                  },
                  items : [
                     {
                        title : "Accordion 1",
                        html  : "Panel content 1!"
                     },
                     {
                        title     : "Accordion 2",
                        overflowY : "scroll",
                        items     : [
                           {
                              xtype : "panel",
                              title : "Panel in accordion",
                              frame : true,
                              html  : "Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet.Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet."
                           }
                  
                        ]
                     },
                     {
                        title     : "Viel Text",
                        overflowY : "scroll",
                        html      : "Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet."
                     }
                  ]
               },
               {
                  xtype     : "tabpanel",
                  width     : 200,
                  height    : 300,
                  activeTab : 0,
                  items     : [
                     {
                        title : "Tab 1",
                        items : [
                           {
                              xtype : "panel",
                              title : "Panel in a Tab",
                              frame : true,
                              html  : "Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet.Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet."
                           }
                  
                        ]
                     },
                     {
                        title     : "Viel Text",
                        overflowY : "auto",
                        html      : "Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet.Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet."
                     }
            
            
                  ]
               },
               {
                  xtype     : "tabpanel",
                  width     : 200,
                  height    : 300,
                  activeTab : 0,
                  items     : [
                     {
                        title    : "Tab 1",
                        closable : true,
                        html     : "Scroller in Tabbar"
                     },
                     {
                        title    : "Tab 2",
                        closable : true,
                        html     : "closable tab"
                     },
                     {
                        title    : "Tab 3",
                        closable : true,
                        html     : "closable tab"
                     },
                     {
                        title    : "Tab 4",
                        closable : true,
                        html     : "Another one"
                     },
                     {
                        title    : "Tab 5",
                        closable : true,
                        html     : "A simple tab"
                     },
                     {
                        title    : "Tab 6",
                        closable : true,
                        html     : "Another one"
                     }
            
                  ]
               },
               {
                  xtype    : "panel",
                  width    : 400,
                  height   : 300,
                  layout   : "border",
                  defaults : {
                     collapsible : true,
                     split       : true,
                     bodyPadding : 10
                  },
                  items : [
                     {
                        title     : "Footer",
                        region    : "south",
                        height    : 100,
                        minHeight : 75,
                        maxHeight : 100,
                        html      : "<p>Footer content</p>"
                     },
                     {
                        title     : "Navigation",
                        region    : "west",
                        floatable : false,
                        margin    : "5 0 0 0",
                        width     : 125,
                        minWidth  : 100,
                        maxWidth  : 250,
                        html      : "<p>Secondary content like navigation links could go here</p>"
                     },
                     {
                        title       : "Main Content",
                        collapsible : false,
                        region      : "center",
                        margin      : "5 0 0 0",
                        html        : "<h2>Main Page</h2><p>This is where the main content would go</p>"
                     }
                  ]
            
               }
            ]
      
         },
   
         {
            title      : "Toolbars & Buttons",
            xtype      : "panel",
            scrollable : true,
            layout     : {
               type  : "vbox",
               align : "stretch"
            },
            defaults : {
               margin : 8
            },
      
            items : [
               {
                  title : "Buttons in Toolbars tbar / bar + as default Panel Content",
                  xtype : "panel",
                  flex  : 1,
            
                  tbar : me.defaultButtonSet,
            
                  bbar  : me.defaultButtonSet,
                  items : me.defaultButtonSet
               },
               {
                  title           : "Breadcrumbs",
                  xtype           : "panel",
                  flex            : 1,
                  overflowHandler : "scroller",
            
                  tbar : [
                     {
                        xtype     : "breadcrumb",
                        showIcons : true,
                        store     : {
                           type : "files"
                        },
                  
                        items : [
                           {
                              xtype : "component",
                              html  : "Split buttons:",
                              style : {
                                 "margin-left"  : "10px",
                                 "margin-right" : "10px"
                              }
                           }
                        ]
                     }
                  ],
            
                  bbar : [
                     {
                        xtype           : "breadcrumb",
                        showIcons       : true,
                        useSplitButtons : false,
                        store           : {
                           type : "files"
                        },
                  
                        items : [
                           {
                              xtype : "component",
                              html  : "Normal buttons:",
                              style : {
                                 "margin-left"  : "10px",
                                 "margin-right" : "10px"
                              }
                           }
                        ]
                     }
                  ]
               }
            ]
         },
   
         {
      
            title      : "All the Buttons",
            xtype      : "panel",
            header     : false,
            scrollable : true,
            layout     : {
               type  : "vbox",
               align : "stretch"
            },
            defaults : {
               margin : 8
            },
            items : [
               {
                  title : "Buttons",
                  xtype : "panel",
                  frame : true,
                  items : [
              
                     // start definition buttons in all forms
                     {
                        xtype  : "container",
                        layout : {
                           type    : "table",
                           columns : 4,
                           tdAttrs : { style: "padding: 5px 10px;" }
                        },
                        defaults : {
                           bind : {
                              disabled : "{disabled}",
                              tooltip  : "{disabled ? \"Buttons are disabled\" : \"Button tooltip\"}"
                           }
                        },
                  
                        items : [
                           {
                              xtype : "component",
                              html  : "Text Only",
                              bind  : null
                           },
                           {
                              xtype : "button",
                              text  : "Small"
                           },
                           {
                              xtype : "button",
                              text  : "Medium",
                              scale : "medium"
                           },
                           {
                              xtype : "button",
                              text  : "Large",
                              scale : "large"
                           },
                           {
                              xtype : "component",
                              html  : "Icon Only",
                              bind  : null
                           },
                           {
                              iconCls : "x-fal fa-paper-plane",
                              xtype   : "button"
                           },
                           {
                              xtype   : "button",
                              iconCls : "x-fal fa-paper-plane",
                              scale   : "medium"
                           },
                           {
                              xtype   : "button",
                              iconCls : "x-fal fa-paper-plane",
                              scale   : "large"
                           },
                           {
                              xtype : "component",
                              html  : "Icon and Text (left)",
                              bind  : null
                           },
                           {
                              xtype   : "button",
                              iconCls : "x-fal fa-paper-plane",
                              text    : "Small"
                           },
                           {
                              xtype   : "button",
                              iconCls : "x-fal fa-paper-plane",
                              text    : "Medium",
                              scale   : "medium"
                           },
                           {
                              xtype   : "button",
                              iconCls : "x-fal fa-paper-plane",
                              text    : "Large",
                              scale   : "large"
                           },
                           {
                              xtype : "component",
                              html  : "Secondary",
                              bind  : null
                           },
                           {
                              xtype   : "button",
                              ui      : "secondary",
                              iconCls : "x-fal fa-cat",
                              text    : "Small"
                           },
                           {
                              xtype   : "button",
                              ui      : "secondary",
                              iconCls : "x-fal fa-cat",
                              text    : "Medium",
                              scale   : "medium"
                           },
                           {
                              xtype   : "button",
                              ui      : "secondary",
                              iconCls : "x-fal fa-cat",
                              text    : "Large",
                              scale   : "large"
                           },
                           {
                              xtype : "component",
                              html  : "Destructive",
                              bind  : null
                           },
                           {
                              xtype   : "button",
                              ui      : "destructive",
                              iconCls : "x-fal fa-trash-alt",
                              text    : "Small",
                              scale   : "small"
                           },
                           {
                              xtype   : "button",
                              ui      : "destructive",
                              iconCls : "x-fal fa-trash-alt",
                              text    : "Medium",
                              scale   : "medium"
                           },
                           {
                              xtype   : "button",
                              ui      : "destructive",
                              iconCls : "x-fal fa-trash-alt",
                              text    : "Large",
                              scale   : "large"
                           },
                           {
                              xtype : "component",
                              html  : "Destructive Secondary",
                              bind  : null
                           },
                           {
                              xtype   : "button",
                              ui      : "destructiveSecondary",
                              iconCls : "x-fal fa-trash-alt",
                              text    : "Small",
                              scale   : "small"
                           },
                           {
                              xtype   : "button",
                              ui      : "destructiveSecondary",
                              iconCls : "x-fal fa-trash-alt",
                              text    : "Medium",
                              scale   : "medium"
                           },
                           {
                              xtype   : "button",
                              ui      : "destructiveSecondary",
                              iconCls : "x-fal fa-trash-alt",
                              text    : "Large",
                              scale   : "large"
                           }
                        ]
                     }
            
                  ],
                  buttons : me.defaultButtonSet
               },
               {
                  title  : "Menu & Split Buttons",
                  xtype  : "panel",
                  frame  : true,
                  layout : {
                     type    : "table",
                     columns : 4,
                     tdAttrs : { style: "padding: 5px 10px;" }
                  },
                  defaults : {
                     menu : [
                        {
                           text : "Menu Item 1"
                        },
                        {
                           text : "Menu Item 2"
                        },
                        {
                           text : "Menu Item 3"
                        }
                     ]
                  },
                  items : [
                     {
                        xtype : "component",
                        html  : "Text Only"
                     },
                     {
                        xtype : "button",
                        text  : "Small"
                     },
                     {
                        xtype : "button",
                        text  : "Medium",
                        scale : "medium"
                     },
                     {
                        xtype : "button",
                        text  : "Large",
                        scale : "large"
                     },
                     {
                        xtype : "component",
                        html  : "Icon Only"
                     },
                     {
                        iconCls : "x-fal fa-home",
                        xtype   : "button"
                     },
                     {
                        xtype   : "button",
                        iconCls : "x-fal fa-home",
                        scale   : "medium"
                     },
                     {
                        xtype   : "button",
                        iconCls : "x-fal fa-home",
                        scale   : "large"
                     },
                     {
                        xtype : "component",
                        html  : "Icon and Text (left)"
                     },
                     {
                        xtype   : "button",
                        iconCls : "x-fal fa-home",
                        text    : "Small"
                     },
                     {
                        xtype   : "button",
                        iconCls : "x-fal fa-home",
                        text    : "Medium",
                        scale   : "medium"
                     },
                     {
                        xtype   : "button",
                        iconCls : "x-fal fa-home",
                        text    : "Large",
                        scale   : "large"
                     },
                     {
                        xtype : "component",
                        html  : "Split Text Only",
                        bind  : null
                     },
                     {
                        xtype : "splitbutton",
                        text  : "Small"
                     },
                     {
                        xtype : "splitbutton",
                        text  : "Medium",
                        scale : "medium"
                     },
                     {
                        xtype : "splitbutton",
                        text  : "Large",
                        scale : "large"
                     },
                     {
                        xtype : "component",
                        html  : "Split Icon Only (toggle)",
                        bind  : null
                     },
                     {
                        xtype        : "splitbutton",
                        iconCls      : "x-fal fa-home",
                        enableToggle : true
                     },
                     {
                        xtype        : "splitbutton",
                        iconCls      : "x-fal fa-home",
                        scale        : "medium",
                        enableToggle : true
                     },
                     {
                        xtype        : "splitbutton",
                        iconCls      : "x-fal fa-home",
                        scale        : "large",
                        enableToggle : true
                     },
                     {
                        xtype : "component",
                        html  : "Split Icon and Text",
                        bind  : null
                     },
                     {
                        xtype   : "splitbutton",
                        iconCls : "x-fal fa-home",
                        text    : "Small"
                     },
                     {
                        xtype   : "splitbutton",
                        iconCls : "x-fal fa-home",
                        text    : "Medium",
                        scale   : "medium"
                     },
                     {
                        xtype   : "splitbutton",
                        iconCls : "x-fal fa-home",
                        text    : "Large",
                        scale   : "large"
                     }
                  ]
               }
            ]
         },
   
         {
      
            title      : "More Buttons",
            xtype      : "panel",
            header     : false,
            scrollable : true,
            layout     : {
               type  : "vbox",
               align : "stretch"
            },
            defaults : {
               margin : 8
            },
            items : [
               {
                  title   : "Button Groups",
                  xtype   : "panel",
                  layout  : "column",
                  cls     : "segmented-buttons",
                  padding : 10,
            
                  frame       : true,
                  defaultType : "fieldcontainer",
                  defaults    : {
                     labelAlign : "top",
                     margin     : "20"
                  },
                  items : [
                     {
                        fieldLabel  : "Toggle Group",
                        columnWidth : 0.25,
                        items       : [
                           {
                              xtype    : "segmentedbutton",
                              vertical : true,
                              bind     : {
                                 disabled : "{disabled}"
                              },
                              items : [
                                 {
                                    text : "Option One"
                                 },
                                 {
                                    text    : "Option Two",
                                    pressed : true
                                 },
                                 {
                                    text : "Option Three"
                                 }
                              ]
                           }
                        ]
                     },
                     {
                        fieldLabel  : "Multiple Toggle",
                        columnWidth : 0.25,
                        items       : [
                           {
                              xtype         : "segmentedbutton",
                              vertical      : true,
                              allowMultiple : true,
                              bind          : {
                                 disabled : "{disabled}"
                              },
                              items : [
                                 {
                                    text    : "Option One",
                                    pressed : true
                                 },
                                 {
                                    text : "Option Two"
                                 },
                                 {
                                    text    : "Option Three",
                                    pressed : true
                                 }
                              ]
                           }
                        ]
                     },
                     {
                        fieldLabel  : "No Toggle",
                        columnWidth : 0.25,
                        items       : [
                           {
                              xtype       : "segmentedbutton",
                              vertical    : true,
                              allowToggle : false,
                              bind        : {
                                 disabled : "{disabled}"
                              },
                              items : [
                                 {
                                    text : "Option One"
                                 },
                                 {
                                    text : "Option Two"
                                 },
                                 {
                                    text : "Option Three"
                                 }
                              ]
                           }
                        ]
                     },
                     {
                        fieldLabel  : "Icons/Arrows",
                        columnWidth : 0.25,
                        items       : [
                           {
                              xtype       : "segmentedbutton",
                              vertical    : true,
                              allowToggle : false,
                              bind        : {
                                 disabled : "{disabled}"
                              },
                              items : [
                                 {
                                    iconCls : BpcCommon.Icons.ACCESS_DENIED,
                                    text    : "Button"
                                 },
                                 {
                                    text : "Menu Button",
                                    menu : [
                                       { text: "Menu Item 1" },
                                       { text: "Menu Item 2" },
                                       { text: "Menu Item 3" }
                                    ]
                                 },
                                 {
                                    xtype : "splitbutton",
                                    text  : "Split Button",
                                    menu  : [
                                       { text: "Menu Item 1" },
                                       { text: "Menu Item 2" },
                                       { text: "Menu Item 3" }
                                    ]
                                 }
                              ]
                           }
                        ]
                     }
                  ]
               },
               {
                  xtype  : "panel",
                  title  : "Buttons in Panel Header",
                  frame  : true,
                  header : {
                     items : me.defaultButtonSet
                  },
                  layout : "hbox",
                  items  : me.defaultButtonSet
               },
               {
                  xtype  : "panel",
                  ui     : "hidden-header-items",
                  title  : "ui: hidden-header-items",
                  frame  : true,
                  header : {
                     items : me.defaultButtonSet
                  },
                  layout : "hbox",
                  items  : me.defaultButtonSet
               }
            ]
         },
   
         {
            title      : "Forms and Grids",
            xtype      : "panel",
            header     : false,
            scrollable : true,
            layout     : {
               type  : "hbox",
               align : "stretch"
            },
            defaults : {
               margin : 8
            },
            items : [
               {
                  xtype       : "fieldset",
                  collapsible : true,
                  defaults    : { anchor: "100%" },
                  title       : "Notifications Test",
                  itemId      : "notificationFieldSet",
                  items       : [
                     {
                        xtype      : "textfield",
                        fieldLabel : "Notification Text",
                        bind       : "{notificationText}"
                     },
                     {
                        xtype      : "radiogroup",
                        fieldLabel : "Typ",
                        columns    : 4,
                        bind       : "{notificationType}",
                        items      : [
                           {
                              boxLabel   : "Info",
                              name       : "notificationType",
                              inputValue : "INFO"
                           },
                           {
                              boxLabel   : "Warnung",
                              name       : "notificationType",
                              inputValue : "WARNING"
                           },
                           {
                              boxLabel   : "Fehler",
                              name       : "notificationType",
                              inputValue : "ERROR"
                           },
                           {
                              boxLabel   : "Frage",
                              name       : "notificationType",
                              inputValue : "QUESTION"
                           }
                        ]
                     },
                     {
                        xtype      : "checkboxgroup",
                        fieldLabel : "Optionen",
                        columns    : 4,
                        items      : [
                           {
                              boxLabel : "PopUp",
                              bind     : "{notificationPopUp}"
                           },
                           {
                              boxLabel : "Toast",
                              bind     : "{notificationToast}"
                           },
                           {
                              boxLabel : "Silent",
                              bind     : "{notificationSilent}"
                           }
                        ]
                     },
                     {
                        xtype      : "radiogroup",
                        fieldLabel : "Toast Ziel",
                        columns    : 4,
                        bind       : {
                           value    : "{notificationToastTarget}",
                           disabled : "{!notificationToast}"
                        },
                        items : [
                           {
                              boxLabel   : "Global",
                              name       : "notificationToastTarget",
                              inputValue : "global",
                              checked    : true
                           },
                           {
                              boxLabel   : "Modul",
                              name       : "notificationToastTarget",
                              inputValue : "module"
                           },
                           {
                              boxLabel   : "Fieldset",
                              name       : "notificationToastTarget",
                              inputValue : "fieldset"
                           }
                        ]
                     },
                     {
                        xtype   : "button",
                        iconCls : "x-fal fa-paper-plane",
                        text    : "Senden",
                        handler : "sendNotification"
                     }
                  ]
               },
               {
                  xtype       : "panel",
                  title       : "Form Validation Demo",
                  frame       : true,
                  width       : 320,
                  defaultType : "textfield",
            
                  items : [
                     {
                        allowBlank : false,
                        fieldLabel : "User ID",
                        name       : "user",
                        emptyText  : "user id",
                        msgTarget  : "under"
                     },
                     {
                        allowBlank : false,
                        fieldLabel : "Password",
                        name       : "pass",
                        emptyText  : "password",
                        inputType  : "password",
                        msgTarget  : "under"
                     },
                     {
                        xtype      : "datefield",
                        allowBlank : false,
                        fieldLabel : "Datum",
                        msgTarget  : "under"
                     }
                  ],
            
                  buttons : [
                     { text: "Login" }
                  ],
            
                  defaults : {
                     anchor     : "100%",
                     labelWidth : 100
                  }
               },
               {
                  xtype  : "panel",
                  layout : "center",
                  title  : "Grid Demo",
                  frame  : true,
                  width  : 500,
                  items  : [
                     {
                        xtype : "gridpanel",
                        store : {
                           fields : [
                              "name",
                              "email",
                              "phone"
                           ],
                           data : [
                              {
                                 name  : "Lisa",
                                 email : "lisa@simpsons.com",
                                 phone : "555-111-1224"
                              },
                              {
                                 name  : "Bart",
                                 email : "bart@simpsons.com",
                                 phone : "555-222-1234"
                              },
                              {
                                 name  : "Homer",
                                 email : "homer@simpsons.com",
                                 phone : "555-222-1244"
                              },
                              {
                                 name  : "Marge",
                                 email : "marge@simpsons.com",
                                 phone : "555-222-1254"
                              }
                           ]
                        },
                        columns : [
                           {
                              header    : "Name",
                              dataIndex : "name"
                           },
                           {
                              header    : "Email",
                              dataIndex : "email",
                              flex      : 1
                           }
                        ],
                        height : 200,
                        width  : 300
                     }
            
                  ],
                  buttons : [
                     {
                        iconCls : "x-fal fa-th",
                        text    : "cell edit demo",
                        handler : "openGridCellEditor"
                     },
                     {
                        iconCls : "x-fal fa-grip-lines",
                        text    : "row edit demo",
                        handler : "openGridRowEditor"
                     },
                     {
                        iconCls : "x-fal fa-grip-lines",
                        text    : "Json Editor Column",
                        handler : "openGridJsonEditorColumn"
                     }
                  ]
               },
               {
                  xtype : "panel",
                  title : "Form Fields",
                  frame : true,
                  width : 320,
                  items : [
                     {
                        xtype      : "bpcComboBox",
                        fieldLabel : "Choose State",
                        store      : Ext.create("Ext.data.Store", {
                           fields : ["abbr", "name"],
                           data   : [{
                              "abbr" : "AL",
                              "name" : "Alabama"
                           }, {
                              "abbr" : "AK",
                              "name" : "Alaska"
                           }, {
                              "abbr" : "null",
                              "name" : null
                           }, {
                              "abbr" : "AZ",
                              "name" : "Arizona"
                           }]
                        }),
                        queryMode    : "local",
                        displayField : "name",
                        valueField   : "abbr"
                     },
                     {
                        xtype      : "bpcDragDropTagField",
                        fieldLabel : "Choose Sequence",
                        store      : [
                           "First",
                           "Second",
                           "Third",
                           "Fourth"
                        ]
                     }
                  ],
            
                  buttons : [
                     { text: "Login" }
                  ],
            
                  defaults : {
                     anchor     : "100%",
                     labelWidth : 100
                  }
               },
            ]
         },
   
         {
            title      : "All the Trees",
            xtype      : "panel",
            header     : false,
            scrollable : true,
            layout     : {
               type    : "table",
               columns : 3,
               tdAttrs : { style: "padding: 10px;" }
            },
            defaults : {
               margin      : 8,
               xtype       : "treepanel",
               width       : 300,
               height      : 200,
               rootVisible : false,
               // Sharing the store synchronizes the views:
               store       : {
                  type : "files"
               },
            },
            items : [
               {
                  title : "Tree"
               }, {
                  title : "Tree with No Lines",
                  lines : false
               }, {
                  title     : "Tree with Arrows",
                  useArrows : true,
               }]
         }


      ];
      
      me.callParent();
   }
});

